/* --COPYRIGHT--,BSD
 * Copyright (c) 2016, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*///*****************************************************************************


#include"FECDecoder.h"

uint_8 decoder(uint_16 data , uint_8 enable)
{
	uint_8 result = data & 0x00ff;
	if(enable)
	{
	uint_8 h[5];
	h[0] = (data ^ (data>>1) ^ (data>>3) ^ (data>>5) ^ (data>>7) ^ (data>>8)) & 0x0001;
	h[1] = (data ^ (data>>2) ^ (data>>3) ^ (data>>6) ^ (data>>7) ^ (data>>9)) & 0x0001;
	h[2] = (data ^ (data>>4) ^ (data>>5) ^ (data>>6) ^ (data>>7) ^ (data>>10)) & 0x0001;
	h[3] = ((data>>1) ^ (data>>2) ^ (data>>3) ^ (data>>4) ^ (data>>5) ^ (data>>6) ^ (data>>7) ^ (data>>11)) & 0x0001;
	h[4] = (data ^ (data>>1) ^ (data>>2) ^ (data>>3) ^ (data>>4) ^ (data>>5) ^ (data>>6) ^ (data>>7) ^ (data>>8) ^ (data>>9) ^ (data>>10) ^ (data>>11) ^ (data>>12)) & 0x0001;
	uint_8 checkData = ( (h[4] & !h[3] & h[2] & h[1] & h[0]) |
			((h[4] & h[3] & !h[2] & !h[1] & h[0]) << 1) |
			((h[4] & h[3] & !h[2] & h[1] & !h[0]) << 2) |
			((h[4] & h[3] & !h[2] & h[1] & h[0]) << 3) |
			((h[4] & h[3] & h[2] & !h[1] & !h[0]) << 4) |
			((h[4] & h[3] & h[2] & !h[1] & h[0]) << 5) |
			((h[4] & h[3] & h[2] & h[1] & !h[0]) << 6) |
			((h[4] & h[3] & h[2] & h[1] & h[0]) << 7) );
	result = result ^ checkData;
	}
	return result;
}
