/* --COPYRIGHT--,BSD
 * Copyright (c) 2016, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*///*****************************************************************************

#ifndef MODULATION_H_
#define MODULATION_H_

#include "defines.h"

//this function is to set modulated bit rate
// parameter is one of :
//        BIT_RATE_125000
//        BIT_RATE_62500
//        BIT_RATE_31250
//        BIT_RATE_25000
//        BIT_RATE_12500
//        BIT_RATE_5000
//        BIT_RATE_1000
void setBitRate(uint_8);

//this function is used to generate the carrier, according to the data's LSB
void modulateOneBit(uint_8);

//enable carrier's timer
void startCarrier(void);
//stop carrier's timer
void stopCarrier(void);
//enable signal's timer
void startSignal(void);
//stop signal's timer
void stopSignal(void);

//structuer Send_Info is used for data modulating
//this function is used to initialize this structure
//the first parameter is a reference of Send_Info
//the second parameter is for FEC enable
void initSendInfo(Send_Info * , uint_8);

#endif /* MODULATION_H_ */
