/* --COPYRIGHT--,BSD
 * Copyright (c) 2016, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*///*****************************************************************************


#include "Modulation.h"

void startCarrier(void) {TA0CTL |= MC__UP | TACLR;}
void stopCarrier(void) {TA0CTL = TASSEL__SMCLK | ID__2 | TACLR;}
void startSignal(void) {TA1CTL |= MC__UP | TACLR;}
void stopSignal(void) {TA1CTL = TASSEL__SMCLK | ID__2 | TACLR;}

void setBitRate(uint_8 data)
{
	TA1CTL |= TACLR;
	TA1CCR0 = data;
}

void modulateOneBit(uint_8 data)
{
	if((data & 0x01) == 0x01)
		SYMBOL_1;
	else
		SYMBOL_0;
}

void initSendInfo(Send_Info *sendInfo , uint_8 enableFEC)
{
	(*sendInfo).counter = 0;
	(*sendInfo).flag = 0;
	if(enableFEC)
		(*sendInfo).length = 13;
	else
		(*sendInfo).length = 8;
}
